import es
import hashlib
import cryptlib
import base64

#plugin information
info = es.AddonInfo()
info.name = "Cryptlib EventScripts Command wrapper"
info.version = "0.2"
info.author = "Hunter"
info.url = "http://www.eventscripts.com/pages/Cryptlib/"
info.description = "Provides basic hash functions for non-python addons"

# Load
def load():
    if not es.exists("command", "cryptlib"):
        es.regcmd("cryptlib", "corelib/crypt/consolecmd", "Supports md5, sha1, base64, rot13 and other hashs.")

# Command stuff
def consolecmd():
    es.dbgmsg(1, "Cryptlib.py: consolecmd: "+str(es.getargs()))
    subcmd = es.getargv(1).lower()
    if subcmd == "list":
        es.dbgmsg("0", "cryptlib provides the following subcommands:")
        es.dbgmsg("0", "list")
        es.dbgmsg("0", "md5 <variable> [string]")
        es.dbgmsg("0", "sha1 <variable> [string]")
        es.dbgmsg("0", "sha224 <variable> [string]")
        es.dbgmsg("0", "sha256 <variable> [string]")
        es.dbgmsg("0", "sha384 <variable> [string]")
        es.dbgmsg("0", "sha512 <variable> [string]")
        es.dbgmsg("0", "base64 encode/decode <variable> [string]")
        es.dbgmsg("0", "rot13 <variable> [string]")
        es.dbgmsg("0", "xor encode/decode <variable> <key> [string]")
        es.dbgmsg("0", "chiffre encode/decode <variable> <key> [string]")
    elif subcmd == "md5":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.md5()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "sha1":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.sha1()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "sha224":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.sha224()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "sha256":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.sha256()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "sha384":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.sha384()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "sha512":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = hashlib.sha512()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.hexdigest()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "base64":
        rvar = es.getargv(3)
        if rvar:
            if es.getargc() > 4:
                istring = es.getargv(4)
            else:
                istring = str(es.ServerVar(rvar))
            icmd = es.getargv(2)
            if icmd.lower() == 'encode':
                es.ServerVar(rvar).set(str(base64.b64encode(istring)))
            elif icmd.lower() == 'decode':
                es.ServerVar(rvar).set(str(base64.b64decode(istring)))
            else:
                es.dbgmsg("0", "cryptlib: Please use encode or decode")
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "rot13":
        rvar = es.getargv(2)
        if rvar:
            if es.getargc() > 3:
                istring = es.getargv(3)
            else:
                istring = str(es.ServerVar(rvar))
            gHash = cryptlib.rot13()
            gHash.update(istring)
            es.ServerVar(rvar).set(str(gHash.output()))
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "xor":
        rvar = es.getargv(3)
        if rvar:
            if es.getargc() > 5:
                istring = es.getargv(5)
            else:
                istring = str(es.ServerVar(rvar))
            icmd = es.getargv(2)
            if icmd.lower() == 'encode':
                ikey = es.getargv(4)
                if (len(ikey) > 0):
                    gHash = cryptlib.xor()
                    gHash.update(istring)
                    gHash.setkey(ikey)
                    es.ServerVar(rvar).set(str(gHash.encode()))
                else:
                    es.dbgmsg("0", "cryptlib: Please provide a valid key")
            elif icmd.lower() == 'decode':
                ikey = es.getargv(4)
                if (len(ikey) > 0):
                    gHash = cryptlib.xor()
                    gHash.update(istring)
                    gHash.setkey(ikey)
                    es.ServerVar(rvar).set(str(gHash.decode()))
                else:
                    es.dbgmsg("0", "cryptlib: Please provide a valid key")
            else:
                es.dbgmsg("0", "cryptlib: Please use encode or decode")
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    elif subcmd == "chiffre":
        rvar = es.getargv(3)
        if rvar:
            if es.getargc() > 5:
                istring = es.getargv(5)
            else:
                istring = str(es.ServerVar(rvar))
            icmd = es.getargv(2)
            if icmd.lower() == 'encode':
                ikey = es.getargv(4)
                if (len(ikey) > 0):
                    gHash = cryptlib.chiffre()
                    gHash.update(istring)
                    gHash.setkey(ikey)
                    es.ServerVar(rvar).set(str(gHash.encode()))
                else:
                    es.dbgmsg("0", "cryptlib: Please provide a valid key")
            elif icmd.lower() == 'decode':
                ikey = es.getargv(4)
                if (len(ikey) > 0):
                    gHash = cryptlib.chiffre()
                    gHash.update(istring)
                    gHash.setkey(ikey)
                    es.ServerVar(rvar).set(str(gHash.decode()))
                else:
                    es.dbgmsg("0", "cryptlib: Please provide a valid key")
            else:
                es.dbgmsg("0", "cryptlib: Please use encode or decode")
        else:
            es.dbgmsg("0", "cryptlib: Please provide a variable")
    else:
        es.dbgmsg("0", "cryptlib: cryptlib <list|md5|sha1|sha224|sha256|sha384|sha512|base64|rot13|xor|chiffre> [encode|decode] <variable> [key] [string]")
